package edu.uoc.android.tfm_magp_2019.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.manager.MyDBHandler;

public class AjustesActivity extends AppCompatActivity implements View.OnClickListener {

    Button botonBorrarAlertas;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_ajustes );
        Toolbar toolbar = (Toolbar) findViewById( R.id.toolbar );
        setSupportActionBar( toolbar );

        // definimos el controlador de Spiner de Ciudad
        Spinner spinnerCiudad = (Spinner) findViewById(R.id.spinnerCiudad);
        String[] ciudades = {"...","Barcelona","Bilbao","Madrid","Sevilla","Valencia"};
        spinnerCiudad.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, ciudades));

        // definimos el controlador de Spiner de Idioma
        Spinner spinnerIdioma = (Spinner) findViewById(R.id.spinnerIdioma);
        String[] idiomas = {"Español","Inglés"};
        spinnerIdioma.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, idiomas));

        // definimos el controlador de Button de borrar alertas
        botonBorrarAlertas = (Button) findViewById( R.id.buttonBorrarAlertas );
        botonBorrarAlertas.setOnClickListener( this );

    }

    @Override
    public void onClick(View v) {
        // Si es pulsado el button borrar
        if(v.getId() == R.id.buttonBorrarAlertas){
            // sentencia de borrado de todas las alertas
            deleteAlerta( v );
        }
    }

    // Invoca al método de borrado de alertas de bbdd
    public void deleteAlerta(View view) {
        //creamos la instancia del controlador
        MyDBHandler dbHandler = new MyDBHandler(this, null, null, 1);

        Toast toast;

        //Ejecución del borrado
        boolean result = dbHandler.deleteHandlerAll();
        if (result) {
            toast = Toast.makeText(view.getContext(), "Se han eliminado todas las alertas programadas", Toast.LENGTH_SHORT);
            toast.show();
        } else
            toast = Toast.makeText(view.getContext(), "Error en la solicitud de borrado de alertas", Toast.LENGTH_SHORT);
            toast.show();
    }

}
