package edu.uoc.android.tfm_magp_2019.activities;

import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.Switch;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.manager.FirebaseFenomenoManager;
import edu.uoc.android.tfm_magp_2019.manager.MyDBHandler;
import edu.uoc.android.tfm_magp_2019.utils.Alertas;
import edu.uoc.android.tfm_magp_2019.utils.Fenomenos;

public class AjustesEstrellasActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {

    private ArrayList estrellasFeno;
    private Fenomenos fenoRow;
    String id_fenomeno;
    String subTipo;

    Switch perseidas;
    Switch liriadas;
    Switch acuaridas;
    Switch tauridas;
    Switch draconidas;
    Switch orionidas;
    Switch andromedidas;
    Switch leonidas;
    Switch geminidas;
    Switch ursidas;
//    Switch todas;

    String literal_perseidas = "Perseidas";
    String literal_acuaridas = "Acuaridas";
    String literal_liriadas = "Liriadas";
    String literal_tauridas = "Tauridas";
    String literal_draconidas = "Draconidas";
    String literal_orionidas  = "Orionidas";
    String literal_andromedidas = "Andromedidas";
    String literal_leonidas = "Leonidas";
    String literal_geminidas = "Geminidas";
    String literal_ursidas = "Ursidas";
//    String literal_todas = "Todas";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_ajustes_estrellas );
        Toolbar toolbar = (Toolbar) findViewById( R.id.toolbar );
        setSupportActionBar( toolbar );

        perseidas = (Switch) findViewById( R.id.switchPerseidas );
        liriadas = (Switch) findViewById( R.id.switchLiriadas );
        acuaridas = (Switch) findViewById( R.id.switchAcuaridas );
        tauridas = (Switch) findViewById( R.id.switchTauridas );
        draconidas = (Switch) findViewById( R.id.switchDraconidas );
        orionidas = (Switch) findViewById( R.id.switchOrionidas );
        andromedidas = (Switch) findViewById( R.id.switchAndromedidas );
        leonidas = (Switch) findViewById( R.id.switchLeonidas );
        geminidas = (Switch) findViewById( R.id.switchGeminidas );
        ursidas = (Switch) findViewById( R.id.switchUrsidas );
//        todas = (Switch) findViewById( R.id.switchTodasEstrellas );


        perseidas.setOnCheckedChangeListener( this );
        liriadas.setOnCheckedChangeListener( this );
        acuaridas.setOnCheckedChangeListener( this );
        tauridas.setOnCheckedChangeListener( this );
        draconidas.setOnCheckedChangeListener( this );
        orionidas.setOnCheckedChangeListener( this );
        andromedidas.setOnCheckedChangeListener( this );
        leonidas.setOnCheckedChangeListener( this );
        geminidas.setOnCheckedChangeListener( this );
        ursidas.setOnCheckedChangeListener( this );

        final List<Fenomenos> fenomenosList = FirebaseFenomenoManager.getInstance().getAllFenomenos();
        estrellasFeno = new ArrayList();

        for (Fenomenos fenomeno : fenomenosList) {
            if (fenomeno.getTipoFenomeno().equals( getString(R.string.estrellas) )) {
                estrellasFeno.add( fenomeno );
            }
        }

        findAlertaInicio( perseidas, literal_perseidas );
        findAlertaInicio( liriadas, literal_liriadas );
        findAlertaInicio( acuaridas, literal_acuaridas );
        findAlertaInicio( tauridas, literal_tauridas );
        findAlertaInicio( draconidas, literal_draconidas );
        findAlertaInicio( orionidas, literal_orionidas );
        findAlertaInicio( andromedidas, literal_andromedidas );
        findAlertaInicio( leonidas, literal_leonidas );
        findAlertaInicio( geminidas, literal_geminidas );
        findAlertaInicio( ursidas, literal_ursidas );
//        findAlertaInicio( todas, literal_todas );

    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {

        switch (buttonView.getId()) {
            case R.id.switchPerseidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_perseidas, perseidas, 7);
                break;
            case R.id.switchLiriadas:
                funcionalidadSwitchs (buttonView, isChecked, literal_liriadas, liriadas, 8);
                break;
            case R.id.switchAcuaridas:
                funcionalidadSwitchs (buttonView, isChecked, literal_acuaridas, acuaridas, 9);
                break;
            case R.id.switchTauridas:
                funcionalidadSwitchs (buttonView, isChecked, literal_tauridas, tauridas, 10);
                break;
            case R.id.switchDraconidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_draconidas, draconidas, 11);
                break;
            case R.id.switchOrionidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_orionidas, orionidas,12);
                break;
            case R.id.switchAndromedidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_andromedidas, andromedidas,13);
                break;
            case R.id.switchLeonidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_leonidas, leonidas,14);
                break;
            case R.id.switchGeminidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_geminidas, geminidas,15);
                break;
            case R.id.switchUrsidas:
                funcionalidadSwitchs (buttonView, isChecked, literal_ursidas, ursidas,16);
                break;
//            case R.id.switchTodasEstrellas:
//                funcionalidadSwitchs (buttonView, isChecked, literal_todas, todas,17);
//                break;
            default:
                break;
        }
    }

    public boolean findHandlerId(View view) {
        MyDBHandler dbHandler = new MyDBHandler( this, null, null, 1 );
        Alertas alertas = dbHandler.findHandlerId( id_fenomeno );

        if (alertas != null) {
            return true;

        } else {
            return false;
        }
    }

    public boolean findAlertaSubtipo(View view) {
        MyDBHandler dbHandler = new MyDBHandler( this, null, null, 1 );
        Alertas alertas = dbHandler.findHandlerSubtipo( subTipo );
        if (alertas != null) {
            return true;

        } else {
            return false;
        }
    }

    public void addAlerta(View view) {
        MyDBHandler dbHandler = new MyDBHandler( this, null, null, 1 );

        Alertas alertas = new Alertas( Integer.parseInt( id_fenomeno ), "" );
        dbHandler.addHandler( alertas );

    }

    public void addAlertaNombre(View view, int numID) {
        MyDBHandler dbHandler = new MyDBHandler( this, null, null, 1 );

        Alertas alertas = new Alertas( numID, subTipo );
        dbHandler.addHandler( alertas );

    }


    public boolean deleteAlertaId(View view, String numID) {
        MyDBHandler dbHandler = new MyDBHandler( this, null,
                null, 1 );
        boolean result = dbHandler.deleteHandlerId( numID );
        return result;
    }


    public void findAlertaInicio(Switch switch_eclipse, String sub_tipo) {
        MyDBHandler dbHandler = new MyDBHandler( this, null, null, 1 );
        Alertas alertas = dbHandler.findHandlerSubtipo( sub_tipo );
        if (alertas != null) {
            switch_eclipse.setChecked( true );
        } else {
            switch_eclipse.setChecked( false );
        }
    }


    public void funcionalidadSwitchs(CompoundButton buttonView, boolean isChecked, String subTipo_ref, Switch switch_ref, int numID){

        boolean borratodas = true;

        for (int i = 0; i < estrellasFeno.size(); i++) {
            fenoRow = (Fenomenos) estrellasFeno.get( i );
            id_fenomeno = fenoRow.getIdFenomeno();
            subTipo = fenoRow.getSubTipo();

            if (subTipo.equals( subTipo_ref )) {
                //buscar que no esté de alta
                if (isChecked) {
                    Boolean result = findHandlerId( buttonView );
                    Boolean resultSubtipo = findAlertaSubtipo( buttonView );
                    //si no está de alta la alerta la damos de alta
                    if (result == false) {
                        addAlerta( buttonView );
                    }
                    if (!resultSubtipo) {
                        addAlertaNombre( buttonView , numID);
                    }
                    switch_ref.setChecked( true );
                } else {
                    //borramos la alerta
                    boolean result = deleteAlertaId( buttonView, id_fenomeno );
                    deleteAlertaId( buttonView, String.valueOf( numID ) );

                    switch_ref.setChecked( false );
                    if (!result) {
                        borratodas = false;
                    }
                }
            }
        }
        if (!borratodas) {
            switch_ref.setChecked( true );
        }
    }

}

