package edu.uoc.android.tfm_magp_2019.activities;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.widget.Toast;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.ValueEventListener;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.manager.FirebaseFenomenoManager;
import edu.uoc.android.tfm_magp_2019.utils.Fenomenos;

public class CargaActivity extends AppCompatActivity implements ValueEventListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d( "Traza servidor - ", "CargaActivity - onCreate 1" );
        setContentView( R.layout.activity_carga );

        ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

        if (!(networkInfo != null && networkInfo.isConnected())) {
            // No hay conexión a Internet en este momento
            Toast toast = Toast.makeText(CargaActivity.this, "Compruebe su conexión a internet, es necesaria para abrir la aplicación", Toast.LENGTH_LONG );
            toast.show();
        }

    }

    @Override
    protected void onStart() {
        super.onStart();
        Log.d( "Traza servidor - ", "CargaActivity - onStart 1" );
        FirebaseFenomenoManager.getInstance().getFenomenosFromServer(this);
    }

    @Override
    public void onDataChange(@NonNull DataSnapshot dataSnapshot) {
        Log.d( "Traza servidor - ", "CargaActivity - onDataChange 1" );
        for (DataSnapshot fenomeno : dataSnapshot.getChildren()) {
            Log.d( "Traza servidor - ", "CargaActivity - onDataChange 2" );
            FirebaseFenomenoManager.getInstance().addfenomenosHashMap(fenomeno.getValue(Fenomenos.class));
        }
        Log.d( "Traza servidor - ", "CargaActivity - onDataChange 3" );
        startMainActivity();
    }

    @Override
    public void onCancelled(@NonNull DatabaseError databaseError) {

        Log.d( "Traza servidor - ", "CargaActivity - onCancelled 1" + databaseError.getMessage() );

        startMainActivity();
    }

    private void startMainActivity() {
        Log.d( "Traza servidor - ", "CargaActivity - onCancelled 1" );
        Intent intentMain = new Intent( this, MainActivity.class );
        Log.d( "Traza servidor - ", "CargaActivity - startMainActivity 2" );
        startActivity(intentMain);
        Log.d( "Traza servidor - ", "CargaActivity - startMainActivity 3" );
        finish();
    }
}