package edu.uoc.android.tfm_magp_2019.activities;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.manager.MyDBHandler;
import edu.uoc.android.tfm_magp_2019.utils.Alertas;


public class EclipseActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {


    public  TextView textViewCuentaAtrasDias;
    public  TextView textViewCuentaAtrasHoras ;
    public  TextView textViewCuentaAtrasMinutos;
    public  TextView textViewCuentaAtrasSegundos;
    public  TextView textViewFecha;

    private  Switch switchButton;

    private String idFenomeno;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_eclipse );
        Toolbar toolbar = (Toolbar) findViewById( R.id.toolbar );
        setSupportActionBar( toolbar );

        Uri uriImage;

        //asociamos ImageView y ponemos la imagen
        ImageView imageView = (ImageView) findViewById( R.id.imageView );

        //asociamos los textView y ponemos su valor
        TextView textViewTipo = (TextView) findViewById( R.id.textView );

        textViewCuentaAtrasDias = (TextView) findViewById( R.id.textViewCADias );
        textViewCuentaAtrasHoras = (TextView) findViewById( R.id.textViewCAHoras );
        textViewCuentaAtrasMinutos = (TextView) findViewById( R.id.textViewCAMin );
        textViewCuentaAtrasSegundos = (TextView) findViewById( R.id.textViewCASeg );
        textViewFecha = (TextView) findViewById( R.id.textViewFechaEclipse );

        // Asociamos botón e implementamos acción en el click
        Button buttonMap = (Button) findViewById( R.id.button );

        buttonMap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent myIntent = new Intent( v.getContext(), MapsEclipseActivity.class );
                myIntent.putExtra("latitud", getIntent().getStringExtra("latitud"));
                myIntent.putExtra("longitud", getIntent().getStringExtra("longitud"));
                startActivity( myIntent );
            }
        });

        switchButton = (Switch) findViewById( R.id.switch1 );

        switchButton.setOnCheckedChangeListener( this );

        //pruebas para paso de datos con Intent
        idFenomeno = getIntent().getStringExtra("id");
        String tipo = getIntent().getStringExtra("tipo");
        String subtipo = getIntent().getStringExtra("subtipo");
        String fecha = getIntent().getStringExtra("fecha");
        Log.d( "los intents: ", " " + tipo + " " + subtipo + " " + fecha);

        String diaFenomeno = fecha.substring( 0,2 );
        String mesFenomeno = fecha.substring( 2,4 );
        String anioFenomeno = fecha.substring( 4,8 );

        textViewTipo.setText( subtipo );
        textViewFecha.setText( diaFenomeno + " - " + mesFenomeno + " - " + anioFenomeno );

        Date fecEventoDate = new Date(  );
        SimpleDateFormat sdf = new SimpleDateFormat("ddMMyyyy");
        try {
            fecEventoDate = sdf.parse(fecha);
        } catch (ParseException ex) {
            Log.v("Exception", ex.getLocalizedMessage());
        }


        Date fechaActual = Calendar.getInstance().getTime();

        long diferenciaFechas = fecEventoDate.getTime() - fechaActual.getTime();

        long diasRestantes = diferenciaFechas / 86400000;
        long restoDias = diferenciaFechas % 86400000;
        long horasRestantes = restoDias / 3600000;
        long restoHoras = restoDias % 3600000;
        long minutosRestantes = restoHoras / 60000;
        long restoMinutos = restoHoras % 60000;
        long segundosRestantes = restoMinutos / 1000;

        CuentaAtrasSegundos ca = new  CuentaAtrasSegundos(restoMinutos, 1000);
        ca.start();

        textViewCuentaAtrasDias.setText( String.valueOf( diasRestantes) );
        textViewCuentaAtrasHoras.setText( String.valueOf( horasRestantes ));
        textViewCuentaAtrasMinutos.setText( String.valueOf( minutosRestantes ) );
        textViewCuentaAtrasSegundos.setText( String.valueOf( segundosRestantes ));

        switch (subtipo){
            case "Eclipse Solar Parcial":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.sol_parcial_g);
                imageView.setImageURI(uriImage);
                break;
            case "Eclipse Solar Total":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.sol_total_g);
                imageView.setImageURI(uriImage);
                break;
            case "Eclipse Solar Anular":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.anular_grande);
                imageView.setImageURI(uriImage);
                break;
            case "Eclipse Lunar Parcial":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.luna_parcial_g);
                imageView.setImageURI( uriImage);
                break;
            case "Eclipse Lunar Penumbral":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.luna_penumbral_g);
                imageView.setImageURI(uriImage);
                break;
            case "Eclipse Lunar Penumbral Parcial":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.luna_penumbral_g);
                imageView.setImageURI(uriImage);
                break;
            case "Eclipse Lunar Total":
                uriImage = Uri.parse("android.resource://" + getPackageName() +"/"+R.drawable.luna_total_g);
                imageView.setImageURI(uriImage);
                break;
        }

        findAlertaInicio(findViewById( android.R.id.content ));

    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        if (switchButton.isChecked()){
            addAlerta(findViewById( android.R.id.content ));
        }else {
            deleteAlertaId(findViewById( android.R.id.content ));
        }
    }

    public class CuentaAtrasSegundos extends CountDownTimer{

        /**
         * @param millisInFuture    The number of millis in the future from the call
         *                          to {@link #start()} until the countdown is done and {@link #onFinish()}
         *                          is called.
         * @param countDownInterval The interval along the way to receive
         *                          {@link #onTick(long)} callbacks.
         */
        public CuentaAtrasSegundos(long millisInFuture, long countDownInterval) {
            super( millisInFuture, countDownInterval );
        }

        @Override
        public void onTick(long millisUntilFinished) {
            textViewCuentaAtrasSegundos.setText( "" + millisUntilFinished / 1000 );
        }

        @Override
        public void onFinish() {
            if (textViewCuentaAtrasMinutos.equals( "00" ) || textViewCuentaAtrasMinutos.equals( "0" )){
                textViewCuentaAtrasMinutos.setText( "59" );
                if (textViewCuentaAtrasHoras.equals( "00" ) || textViewCuentaAtrasHoras.equals( "0" )){
                    textViewCuentaAtrasHoras.setText( "23" );
                    String diasString = textViewCuentaAtrasHoras.toString();
                    int dias = Integer.parseInt(diasString);
                    if (dias > 0){
                        dias = dias -1;
                        textViewCuentaAtrasDias.setText( String.valueOf( dias ) );
                    }
                }else{
                    String horasString = textViewCuentaAtrasHoras.toString();
                    int horas = Integer.parseInt(horasString);
                    horas = horas -1;
                    textViewCuentaAtrasHoras.setText( String.valueOf( horas ) );
                }
            }else{
                String minutsString = textViewCuentaAtrasMinutos.getText().toString();
                int minuts = Integer.valueOf(minutsString);
                minuts = minuts -1;
                textViewCuentaAtrasMinutos.setText( String.valueOf( minuts ) );
            }
            CuentaAtrasSegundos ca = new  CuentaAtrasSegundos(60000, 1000);
            ca.start();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        switch (id){
            case R.id.action_alerts:
                startActivity (new Intent(this, AlertasActivity.class));
                break;
            case  R.id.action_help:
                startActivity (new Intent(this, AyudaActivity.class));
                break;
            case R.id.action_settings:
                startActivity (new Intent(this, AjustesActivity.class));
                break;
        }

        return super.onOptionsItemSelected( item );
    }

    public void findAlertaInicio (View view) {
        MyDBHandler dbHandler = new MyDBHandler(this, null, null, 1);
        Alertas alertas = dbHandler.findHandlerId(idFenomeno);

        if (alertas != null) {
            switchButton.setChecked( true );

        } else {
            switchButton.setChecked( false );
        }
    }

    public void addAlerta (View view) {
        MyDBHandler dbHandler = new MyDBHandler(this, null, null, 1);

        Alertas alertas = new Alertas(Integer.parseInt( idFenomeno ),"");
        dbHandler.addHandler(alertas);

    }

    public void deleteAlertaId(View view) {
        MyDBHandler dbHandler = new MyDBHandler(this, null,
                null, 1);
        boolean result = dbHandler.deleteHandlerId(idFenomeno);
        if (result) {
            switchButton.setChecked( false );
        } else
            switchButton.setChecked( true );
    }
}
