package edu.uoc.android.tfm_magp_2019.activities;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.manager.MyDBHandler;
import edu.uoc.android.tfm_magp_2019.utils.Alertas;
import lecho.lib.hellocharts.model.Axis;
import lecho.lib.hellocharts.model.AxisValue;
import lecho.lib.hellocharts.model.Line;
import lecho.lib.hellocharts.model.LineChartData;
import lecho.lib.hellocharts.model.PointValue;
import lecho.lib.hellocharts.model.Viewport;
import lecho.lib.hellocharts.view.LineChartView;

public class EstrellasActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {

    List yAxisValues = new ArrayList();
    List axisValues = new ArrayList();
    Line line = new Line(yAxisValues).setColor(Color.parseColor("#9C27B0"));
    private Switch switchButton;
    private String idFenomeno;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_estrellas );
        Toolbar toolbar = (Toolbar) findViewById( R.id.toolbar );
        setSupportActionBar( toolbar );

        //asociamos los textView y ponemos su valor
        TextView textViewTipo = (TextView) findViewById( R.id.textViewEstrellas );
        TextView textViewFecha = (TextView) findViewById( R.id.textViewEstrellas2 );
        switchButton = (Switch) findViewById( R.id.switchestrellas );

        switchButton.setOnCheckedChangeListener( this );

        textViewTipo.setText( getIntent().getStringExtra("tipo") );
        textViewFecha.setText( getIntent().getStringExtra("fecha") );
        idFenomeno =  getIntent().getStringExtra("id");

        String datosGrafica = getIntent().getStringExtra( "visibilidad" ); // formato ->"07-08-09-10-11,0-0-3-4-0-0"

        LineChartView lineChartView = findViewById(R.id.chart);

        String[] axisData = {
                datosGrafica.substring( 0,2 ),
                datosGrafica.substring( 3,5 ),
                datosGrafica.substring( 6,8 ),
                datosGrafica.substring( 9,11 ),
                datosGrafica.substring( 12,14 )
        };

        int yUno = Integer.parseInt( datosGrafica.substring( 15,16 ) );
        int yDos = Integer.parseInt( datosGrafica.substring( 17,18 ) );
        int yTres = Integer.parseInt( datosGrafica.substring( 19,20 ) );
        int yCuatro = Integer.parseInt( datosGrafica.substring( 21,22 ) );
        int yCinco = Integer.parseInt( datosGrafica.substring( 23,24 ) );

        int[] yAxisData = {yUno, yDos, yTres, yCuatro, yCinco};


        for(int i = 0; i < axisData.length; i++){
            axisValues.add(i, new AxisValue(i).setLabel(axisData[i]));
        }

        for (int i = 0; i < yAxisData.length; i++){
            yAxisValues.add(new PointValue(i, yAxisData[i]));
        }

        List lines = new ArrayList();
        lines.add(line);

        LineChartData data = new LineChartData();
        data.setLines(lines);

        lineChartView.setLineChartData(data);

        Axis axis = new Axis();
        axis.setValues(axisValues);
        data.setAxisXBottom(axis);

        Axis yAxis = new Axis();
        data.setAxisYLeft(yAxis);

        axis.setTextSize(16);
        axis.setTextColor(Color.parseColor("#03A9F4"));
        yAxis.setTextColor(Color.parseColor("#03A9F4"));
        yAxis.setTextSize(16);
        yAxis.setName(getString(R.string.frecuencia));
        axis.setName(getString(R.string.dias));

        Viewport viewport = new Viewport(lineChartView.getMaximumViewport());
        viewport.top =10;
        viewport.bottom=0;
        lineChartView.setMaximumViewport(viewport);
        lineChartView.setCurrentViewport(viewport);

        findAlertaInicio(findViewById( android.R.id.content ));

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        switch (id){
            case R.id.action_alerts:
                startActivity (new Intent(this, AlertasActivity.class));
                break;
            case  R.id.action_help:
                startActivity (new Intent(this, AyudaActivity.class));
                break;
            case R.id.action_settings:
                startActivity (new Intent(this, AjustesActivity.class));
                break;
        }

        return super.onOptionsItemSelected( item );
    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        if (switchButton.isChecked()){
            addAlerta(findViewById( android.R.id.content ));
        }else {
            deleteAlertaId(findViewById( android.R.id.content ));

        }
    }

    public void findAlertaInicio (View view) {

        MyDBHandler dbHandler = new MyDBHandler(this, null, null, 1);
        Alertas alertas = dbHandler.findHandlerId(idFenomeno);

        if (alertas != null) {
            switchButton.setChecked( true );

        } else {
            switchButton.setChecked( false );
        }
    }

    public void addAlerta (View view) {
        MyDBHandler dbHandler = new MyDBHandler(this, null, null, 1);

        Alertas alertas = new Alertas(Integer.parseInt( idFenomeno ),"");
        dbHandler.addHandler(alertas);

    }

    public void deleteAlertaId(View view) {
        MyDBHandler dbHandler = new MyDBHandler(this, null,
                null, 1);
        boolean result = dbHandler.deleteHandlerId(idFenomeno);
        if (result) {
            switchButton.setChecked( false );
        } else
            switchButton.setChecked( true );
    }
}
