package edu.uoc.android.tfm_magp_2019.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.fragments.EclipseFragment;
import edu.uoc.android.tfm_magp_2019.fragments.EstrellasFragment;
import edu.uoc.android.tfm_magp_2019.fragments.LunarFragment;

public class MainActivity extends AppCompatActivity {

    /**
     * The {@link android.support.v4.view.PagerAdapter} that will provide
     * fragments for each of the sections. We use a
     * {@link FragmentPagerAdapter} derivative, which will keep every
     * loaded fragment in memory. If this becomes too memory intensive, it
     * may be best to switch to a
     * {@link android.support.v4.app.FragmentStatePagerAdapter}.
     */


    /**
     * The {@link ViewPager} that will host the section contents.
     */
    private ViewPager mViewPager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_main );

        Toolbar toolbar = (Toolbar) findViewById( R.id.toolbar );
        setSupportActionBar( toolbar );

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById( R.id.container );
        setupViewAdapter( mViewPager );

        TabLayout tabLayout = (TabLayout) findViewById( R.id.tabs );
        tabLayout.setupWithViewPager( mViewPager );
    }


    private void setupViewAdapter (ViewPager viewPager){
        SectionsPagerAdapter adapter = new SectionsPagerAdapter(getSupportFragmentManager());

        adapter.addFragment( new EclipseFragment(), getString( R.string.tab_text_1 ) );
        adapter.addFragment( new LunarFragment(), getString( R.string.tab_text_2 ) );
        adapter.addFragment( new EstrellasFragment(), getString( R.string.tab_text_3 ) );
        viewPager.setAdapter( adapter );

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate( R.menu.menu_main, menu );
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        switch (id){
            case R.id.action_alerts:
                startActivity (new Intent(this, AlertasActivity.class));
                break;
            case  R.id.action_help:
                startActivity (new Intent(this, AyudaActivity.class));
                break;
            case R.id.action_settings:
                startActivity (new Intent(this, AjustesActivity.class));
                break;
        }

        return super.onOptionsItemSelected( item );
    }


    /**
     * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
     * one of the sections/tabs/pages.
     */
    public class SectionsPagerAdapter extends FragmentPagerAdapter {

        private final List<Fragment> mFragmentList = new ArrayList<>();
        private final List<String> mFragmentTitleList = new ArrayList<>();

        public  void addFragment (Fragment fragment, String title){

            mFragmentList.add( fragment );
            mFragmentTitleList.add( title );
        }

        public SectionsPagerAdapter(FragmentManager fm){
            super(fm);

        }

        @Nullable
        @Override
        public CharSequence getPageTitle(int position) {
            return mFragmentTitleList.get( position );
        }

        @Override
        public Fragment getItem(int i) {
            return mFragmentList.get( i );
        }

        @Override
        public int getCount() {
            return mFragmentList.size();
        }
    }
}
