package edu.uoc.android.tfm_magp_2019.activities;

import android.graphics.Color;
import android.support.v4.app.FragmentActivity;
import android.os.Bundle;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.CircleOptions;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import edu.uoc.android.tfm_magp_2019.R;

public class MapsEclipseActivity extends FragmentActivity implements OnMapReadyCallback {

    private GoogleMap mMap;
    private long latitud;
    private long longitud;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
        setContentView( R.layout.activity_maps_eclipse );

        // Obtain the SupportMapFragment and get notified when the map is ready to be used.
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById( R.id.map );
        mapFragment.getMapAsync( this );

        longitud = Integer.parseInt( getIntent().getStringExtra("longitud") );
        latitud = Integer.parseInt( getIntent().getStringExtra("latitud") );

    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;

        // Add a marker in Sydney and move the camera
        LatLng eclipse = new LatLng( latitud, longitud );
        mMap.addMarker( new MarkerOptions().position( eclipse ).title( getString(R.string.mejor_visibilidad) ) );
        mMap.moveCamera( CameraUpdateFactory.newLatLng( eclipse ) );
        mMap.animateCamera(CameraUpdateFactory.zoomTo(5));
        drawCircle(new LatLng(latitud, longitud));
    }

    //dibujamos el circulo
    private void drawCircle(LatLng point){

        // Instantiating CircleOptions to draw a circle around the marker
        CircleOptions circleOptions = new CircleOptions();

        // Specifying the center of the circle
        circleOptions.center(point);

        // Radius of the circle
        circleOptions.radius(300000);

        // Border color of the circle
        circleOptions.strokeColor(Color.BLACK);

        // Fill color of the circle
        circleOptions.fillColor(0x30ff0000);

        // Border width of the circle
        circleOptions.strokeWidth(2);

        // Adding the circle to the GoogleMap
        mMap.addCircle(circleOptions);

    }
}
