package edu.uoc.android.tfm_magp_2019.adapters;

import android.app.Activity;
import android.content.Context;
import android.net.Uri;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.utils.Fenomenos;
import edu.uoc.android.tfm_magp_2019.utils.Level;

public class LevelAdapter extends ArrayAdapter<Level> {

    static Context context;
    static int layoutResourceId;
    //Level data[] = null;
    public ArrayList data;

    //public LevelAdapter(Context context, int layoutResourceId, Level[] data) {
    public LevelAdapter(Context context, int layoutResourceId, ArrayList data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }


    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View row = convertView;
        eclipHolder holder = null;

        if(row == null)
        {
            LayoutInflater inflater = ((Activity)context).getLayoutInflater();
            row = inflater.inflate(layoutResourceId, parent, false);
            //row.setMinimumHeight(200);
            holder = new eclipHolder();
            holder.imgIcon = (ImageView)row.findViewById(R.id.imageView2);
            holder.txtTitle = (TextView)row.findViewById(R.id.txtTitle);
            holder.txtTitle2 = (TextView)row.findViewById(R.id.txtTitle2);

            row.setTag(holder);
        }
        else
        {
            holder = (eclipHolder)row.getTag();
        }

       // Level eclip = data[position];
        Fenomenos eclip = (Fenomenos) data.get( position );
        holder.txtTitle.setText(eclip.getSubTipo());

        String fechaFenomeno = eclip.getFecha();
        String diaFenomeno = fechaFenomeno.substring( 0,2 );
        String mesFenomeno = fechaFenomeno.substring( 2,4 );
        String anioFenomeno = fechaFenomeno.substring( 4,8 );

        holder.txtTitle2.setText(diaFenomeno + "-" + mesFenomeno + "-" + anioFenomeno);

        Uri uriImage;

switch (eclip.getSubTipo()){
    case "Eclipse Solar Parcial":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.sol_parcial_p);
        holder.imgIcon.setImageURI(uriImage);
        break;
    case "Eclipse Solar Total":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.sol_total_p);
        holder.imgIcon.setImageURI(uriImage);
        break;
    case "Eclipse Solar Anular":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.anular_peque);
        holder.imgIcon.setImageURI(uriImage);
        break;
    case "Eclipse Lunar Parcial":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.lunar_parcial_p);
        holder.imgIcon.setImageURI( uriImage);
        break;
    case "Eclipse Lunar Penumbral":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.luna_penumbral_p);
        holder.imgIcon.setImageURI(uriImage);
        break;
    case "Eclipse Lunar Penumbral Parcial":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.luna_penumbral_p);
        holder.imgIcon.setImageURI(uriImage);
        break;
    case "Eclipse Lunar Total":
        uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.luna_total_p);
        holder.imgIcon.setImageURI(uriImage);
        break;
}

        return row;
    }

    static class eclipHolder
    {
        ImageView imgIcon;
        TextView txtTitle;
        TextView txtTitle2;
    }

}