package edu.uoc.android.tfm_magp_2019.adapters;

import android.app.Activity;
import android.content.Context;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.utils.Fenomenos;
import edu.uoc.android.tfm_magp_2019.utils.LevelEstrellas;

public class LevelAdapterEstrellas extends ArrayAdapter<LevelEstrellas> {

    static Context context;
    static int layoutResourceId;
    //LevelEstrellas data[] = null;
    public ArrayList data;

    //public LevelAdapterEstrellas(Context context, int layoutResourceId, LevelEstrellas[] data) {
    public LevelAdapterEstrellas(Context context, int layoutResourceId, ArrayList data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }


    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View row = convertView;
        estreHolder holder = null;

        if(row == null)
        {
            LayoutInflater inflater = ((Activity)context).getLayoutInflater();
            row = inflater.inflate(layoutResourceId, parent, false);
            //row.setMinimumHeight(200);
            holder = new estreHolder();
            holder.imgIcon = (ImageView)row.findViewById(R.id.imageView2);
            holder.txtTitle = (TextView)row.findViewById(R.id.txtTitle);
            holder.txtTitle2 = (TextView)row.findViewById(R.id.txtTitle2);

            row.setTag(holder);
        }
        else
        {
            holder = (estreHolder)row.getTag();
        }

        Fenomenos estre = (Fenomenos) data.get( position );
        holder.txtTitle.setText(estre.getSubTipo());

        String diaInicio = estre.getFecha().substring( 0, 2 );
        String diaFin = estre.getFecha().substring( 2, 4 );
        String mesEstrellas = estre.getFecha().substring( 4, 6 );

        String literalMesRet = traducirMes(mesEstrellas);

        //String intevaloFechas = String.valueOf( "Del " + diaInicio + " al " + diaFin + " de " + literalMesRet );
        String intervaloFechas = String.valueOf( context.getString(R.string.del) + " " + diaInicio + " " + context.getString(R.string.al) + " "  + diaFin + " " + context.getString(R.string.de) + " "  + literalMesRet );

        holder.txtTitle2.setText(intervaloFechas);

        Uri uriImage;

        switch (estre.getVisibilidad().getLatitud()){
            case "1":
                uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.una_estrella);
                holder.imgIcon.setImageURI(uriImage);
                break;
            case "2":
                uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.dos_estrellas);
                holder.imgIcon.setImageURI(uriImage);
                break;
            case "3":
                uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.tres_estrellas);
                holder.imgIcon.setImageURI(uriImage);
                break;
            case "4":
                uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.cuatro_estrellas);
                holder.imgIcon.setImageURI(uriImage);
                break;
            case "5":
                uriImage = Uri.parse("android.resource://" + context.getPackageName() +"/"+R.drawable.cinco_estrellas_);
                holder.imgIcon.setImageURI(uriImage);
                break;
        }

        return row;
    }

    public String traducirMes(String mes){
        String literalMes;
        switch (mes){
            case "01":
                literalMes ="Enero";
                return literalMes; 
            case "02":
                literalMes ="Febrero";
                return literalMes;
            case "03":
                literalMes ="Marzo";
                return literalMes;
            case "04":
                literalMes ="Abril";
                return literalMes;
            case "05":
                literalMes ="Mayo";
                return literalMes;
            case "06":
                literalMes ="Junio";
                return literalMes;
            case "07":
                literalMes ="Julio";
                return literalMes;
            case "08":
                literalMes ="Agosto";
                return literalMes;
            case "09":
                literalMes ="Septiembre";
                return literalMes;
            case "10":
                literalMes ="Octubre";
                return literalMes;
            case "11":
                literalMes ="Noviembre";
                return literalMes;
            case "12":
                literalMes ="Diciembre";
                return literalMes;
        }
        return "";
    }
    
    static class estreHolder
    {
        ImageView imgIcon;
        TextView txtTitle;
        TextView txtTitle2;
    }

}