package edu.uoc.android.tfm_magp_2019.fragments;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import edu.uoc.android.tfm_magp_2019.R;
import edu.uoc.android.tfm_magp_2019.activities.EstrellasActivity;
import edu.uoc.android.tfm_magp_2019.adapters.LevelAdapter;
import edu.uoc.android.tfm_magp_2019.adapters.LevelAdapterEstrellas;
import edu.uoc.android.tfm_magp_2019.manager.FirebaseFenomenoManager;
import edu.uoc.android.tfm_magp_2019.utils.Fenomenos;
import edu.uoc.android.tfm_magp_2019.utils.LevelEstrellas;


public class EstrellasFragment extends Fragment {

    private static final String TAG = "EstrellasFragment";

    private ArrayList estrellasFeno;
    private Fenomenos fenoRow;
    private LevelAdapterEstrellas adp;
    private ListView listView;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate( R.layout.estrellasfragment, container, false );

        // inicializamos la listView
        listView = (ListView) view.findViewById( R.id.estrellasList );

        // Recuperamos todos los fenomenos descargados del servidor
        final List<Fenomenos> fenomenosList = FirebaseFenomenoManager.getInstance().getAllFenomenos();
        estrellasFeno = new ArrayList();

        // filtramos el listado par recuperar unicamente los de tipo Estrellas
        for (Fenomenos fenomeno : fenomenosList) {
            if (fenomeno.getTipoFenomeno().equals( getString( R.string.estrellas ) )){
                estrellasFeno.add( fenomeno );
            }
        }

        // pasamos la información filtrada al adapter para que cargue la listView
        adp=new LevelAdapterEstrellas(getContext(), R.layout.itemlist_estrellas, estrellasFeno);
        listView.setAdapter(adp);

        // configuramos las acciones a realizar al pulsar un elemento de la listView
        listView.setOnItemClickListener( new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                // Usaremos position para recoger los valores del eclipse del array que tengamos y lo pasatemos con intent a la nueva activity
                fenoRow = (Fenomenos) estrellasFeno.get( position );

                // obtenemos el valor del día, me sy año
                String diaInicio = fenoRow.getFecha().substring( 0, 2 );
                String diaFin = fenoRow.getFecha().substring( 2, 4 );
                String mesEstrellas = fenoRow.getFecha().substring( 4, 6 );

                // traducimos el entero mes a su literal
                String literalMesRet = traducirMes(mesEstrellas);

                // preaparamos el label de fecha que vamos a mostrar en ventana
                String intervaloFechas = String.valueOf( getString(R.string.del) + " " + diaInicio + " " + getString(R.string.al) + " "  + diaFin + " " + getString(R.string.de) + " "  + literalMesRet );

                //definimos el intent que abrirá la neuva activity y pasamos la información que necesita
                Intent myIntent = new Intent( view.getContext(), EstrellasActivity.class );
                myIntent.putExtra( "tipo", fenoRow.getSubTipo() );
                myIntent.putExtra( "fecha", intervaloFechas );
                myIntent.putExtra( "visibilidad", fenoRow.getVisibilidad().getLongitud() );
                myIntent.putExtra( "id", fenoRow.getIdFenomeno() );

                // ejecutamos el intent
                startActivityForResult( myIntent, 0 );
            }
        } );

        return view;
    }

    // traduce un literal numeroco de el 01 al 12 por el literal del mes correspondiente
    public String traducirMes(String mes){
        String literalMes;
        switch (mes){
            case "01":
                literalMes =getString(R.string.literal_enero);
                return literalMes;
            case "02":
                literalMes =getString(R.string.literal_febrero);
                return literalMes;
            case "03":
                literalMes =getString(R.string.literal_marzo);
                return literalMes;
            case "04":
                literalMes =getString(R.string.literal_abril);
                return literalMes;
            case "05":
                literalMes =getString(R.string.literal_mayo);
                return literalMes;
            case "06":
                literalMes =getString(R.string.literal_junio);
                return literalMes;
            case "07":
                literalMes =getString(R.string.literal_julio);
                return literalMes;
            case "08":
                literalMes =getString(R.string.literal_agosto);
                return literalMes;
            case "09":
                literalMes =getString(R.string.literal_septiemnbre);
                return literalMes;
            case "10":
                literalMes =getString(R.string.literal_octubre);
                return literalMes;
            case "11":
                literalMes =getString(R.string.literal_noviembre);
                return literalMes;
            case "12":
                literalMes =getString(R.string.literal_diciembre);
                return literalMes;
        }
        return "";
    }

}