package edu.uoc.android.tfm_magp_2019.manager;


import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import edu.uoc.android.tfm_magp_2019.utils.Alertas;

/**
 * Created by Admin on 04/06/2018.
 */

public class MyDBHandler extends SQLiteOpenHelper {

    private static final int DATABASE_VERSION = 1;
    private static final String DATABASE_NAME = "alertaDB.db";
    public static final String TABLE_ALERTAS = "alertas";
    public static final String COLUMN_ID = "AlertasID";
    public static final String COLUMN_NAME = "AlertasName";

    public MyDBHandler(Context context, String name, SQLiteDatabase.CursorFactory factory, int version)
    {
        super(context, DATABASE_NAME, factory, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        String CREATE_ALERTAS_TABLE = "CREATE TABLE " +
                TABLE_ALERTAS + "(" + COLUMN_ID + " INTEGER PRIMARY KEY," + COLUMN_NAME
                + " TEXT " + ")";
        db.execSQL(CREATE_ALERTAS_TABLE);

    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion,
                          int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + TABLE_ALERTAS);
        onCreate(db);

    }

    public void addHandler(Alertas alerta) {
        ContentValues values = new ContentValues();
        values.put(COLUMN_ID, alerta.getID());
        values.put(COLUMN_NAME, alerta.getAlertasName());
        SQLiteDatabase db = this.getWritableDatabase();
        db.insert(TABLE_ALERTAS, null, values);
        db.close();
    }

    public Alertas findHandlerSubtipo(String alertaname) {
        String query = "Select * FROM " + TABLE_ALERTAS + " WHERE " +
                COLUMN_NAME + " = '" + alertaname + "'";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        Alertas alerta = new Alertas();
        if (cursor.moveToFirst()) {
            cursor.moveToFirst();
            alerta.setID(0);
            alerta.setAlertasName(cursor.getString(1));
            cursor.close();
        } else {
            alerta = null;
        }
        db.close();
        return alerta;
    }

    public Alertas findHandlerId(String alertaId) {
        String query = "Select * FROM " + TABLE_ALERTAS + " WHERE " +
                COLUMN_ID + " = '" + alertaId + "'";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        Alertas alerta = new Alertas();
        if (cursor.moveToFirst()) {
            cursor.moveToFirst();
            alerta.setID(Integer.parseInt(cursor.getString(0)));
            alerta.setAlertasName(cursor.getString(1));
            cursor.close();
        } else {
            alerta = null;
        }
        db.close();
        return alerta;
    }

    public String loadHandler() {
        String result = "";
        String query = "Select*FROM " + TABLE_ALERTAS;
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        while (cursor.moveToNext()) {
            int result_0 = cursor.getInt(0);
            String result_1 = cursor.getString(1);
            result += String.valueOf(result_0) + " " + result_1 +
                    System.getProperty("line.separator");
        }
        cursor.close();
        db.close();
        return result;
    }

    public boolean deleteHandlerId(String ID) {
        boolean result = false;
        String query = "Select*FROM " + TABLE_ALERTAS + " WHERE " + COLUMN_ID + " = '" + ID + "'";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        Alertas alerta = new Alertas();
        if (cursor.moveToFirst()) {
            alerta.setID(Integer.parseInt(cursor.getString(0)));
            db.delete(TABLE_ALERTAS, COLUMN_ID + "=?",
                    new String[] {
                            String.valueOf(alerta.getID())
                    });
            cursor.close();
            result = true;
        }
        db.close();
        return result;
    }

    public boolean deleteHandler(String NAME) {
        boolean result = false;
        String query = "Select*FROM " + TABLE_ALERTAS + " WHERE " + COLUMN_NAME + " = '" + NAME + "'";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        Alertas alerta = new Alertas();
        if (cursor.moveToFirst()) {
            alerta.setAlertasName(cursor.getString(0));
            db.delete(TABLE_ALERTAS, COLUMN_NAME + "=?",
                    new String[] {
                            alerta.getAlertasName()
                    });
            cursor.close();
            result = true;
        }
        db.close();
        return result;
    }

    public boolean deleteHandlerAll() {
        boolean result = false;

        SQLiteDatabase db = this.getWritableDatabase();
       if(db.delete( TABLE_ALERTAS, null, null ) >= 0){
            result = true;
        }
        //db.execSQL("delete from "+ TABLE_ALERTAS);
        db.close();
        return result;
    }

    public boolean updateHandler(int ID, String name) {
        SQLiteDatabase db = this.getWritableDatabase();
        ContentValues args = new ContentValues();
        args.put(COLUMN_ID, ID);
        args.put(COLUMN_NAME, name);
        return db.update(TABLE_ALERTAS, args, COLUMN_ID + "=" + ID, null) > 0;
    }
}

